﻿using System;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Threading;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Animation;

namespace SilverlightApplication
{
	public partial class Page : UserControl
	{
		public Page()
		{
			InitializeComponent();
			AnimationManager.SetIsAnimationEnabled(this.radExpander, true);
			this.Loaded += new RoutedEventHandler(Page_Loaded);
		}

		void Page_Loaded(object sender, RoutedEventArgs e)
		{
			if (this.radExpander != null)
			{
				this.radExpander.IsExpanded = true;
			}
		}

		private void DirectionDown_Checked(object sender, RoutedEventArgs e)
		{
			this.OrientExpander(Telerik.Windows.Controls.ExpandDirection.Down);
		}

		private void DirectionUp_Checked(object sender, RoutedEventArgs e)
		{
			this.OrientExpander(Telerik.Windows.Controls.ExpandDirection.Up);
		}

		private void DirectionRight_Checked(object sender, RoutedEventArgs e)
		{
			this.OrientExpander(Telerik.Windows.Controls.ExpandDirection.Right);
		}

		private void DirectionLeft_Checked(object sender, RoutedEventArgs e)
		{
			this.OrientExpander(Telerik.Windows.Controls.ExpandDirection.Left);
		}

		private void OrientExpander(Telerik.Windows.Controls.ExpandDirection expandDirection)
		{
			if (this.radExpander == null)
			{
				return;
			}
			this.radExpander.IsExpanded = false;
			this.radExpander.ExpandDirection = expandDirection;
			if (expandDirection == Telerik.Windows.Controls.ExpandDirection.Down)
			{
				this.radExpander.HorizontalAlignment = HorizontalAlignment.Stretch;
				this.radExpander.VerticalAlignment = VerticalAlignment.Top;
				this.expanderCaption.Visibility = Visibility.Visible;
				this.imageContainer.Orientation = System.Windows.Controls.Orientation.Horizontal;
				this.imageContainer.HorizontalAlignment = HorizontalAlignment.Stretch;
				this.imageContainer.VerticalAlignment = VerticalAlignment.Bottom;
			}
			else if (expandDirection == Telerik.Windows.Controls.ExpandDirection.Up)
			{
				this.radExpander.HorizontalAlignment = HorizontalAlignment.Stretch;
				this.radExpander.VerticalAlignment = VerticalAlignment.Bottom;
				this.expanderCaption.Visibility = Visibility.Visible;
				this.imageContainer.Orientation = System.Windows.Controls.Orientation.Horizontal;
				this.imageContainer.HorizontalAlignment = HorizontalAlignment.Stretch;
				this.imageContainer.VerticalAlignment = VerticalAlignment.Top;
			}
			else if (expandDirection == Telerik.Windows.Controls.ExpandDirection.Left)
			{
				this.radExpander.HorizontalAlignment = HorizontalAlignment.Right;
				this.radExpander.VerticalAlignment = VerticalAlignment.Stretch;
				this.expanderCaption.Visibility = Visibility.Collapsed;
				this.imageContainer.Orientation = System.Windows.Controls.Orientation.Vertical;
				this.imageContainer.HorizontalAlignment = HorizontalAlignment.Left;
				this.imageContainer.VerticalAlignment = VerticalAlignment.Stretch;
			}
			else // if (expandDirection == ExpandDirection.Right)
			{
				this.radExpander.HorizontalAlignment = HorizontalAlignment.Left;
				this.radExpander.VerticalAlignment = VerticalAlignment.Stretch;
				this.expanderCaption.Visibility = Visibility.Collapsed;
				this.imageContainer.Orientation = System.Windows.Controls.Orientation.Vertical;
				this.imageContainer.HorizontalAlignment = HorizontalAlignment.Right;
				this.imageContainer.VerticalAlignment = VerticalAlignment.Stretch;
			}

			this.radExpander.IsExpanded = true;
		}

		private void EnableAnimation_Checked(object sender, RoutedEventArgs e)
		{
			if (this.radExpander == null)
			{
				return;
			}
			AnimationManager.SetIsAnimationEnabled(this.radExpander, (sender as CheckBox).IsChecked == true);
		}
	}
}
